package cn.com.qmth.examcloud.core.oe.task.service;

import cn.com.qmth.examcloud.core.oe.student.dao.entity.ExamRecordDataEntity;
import cn.com.qmth.examcloud.support.enums.ExamRecordStatus;
import cn.com.qmth.examcloud.support.enums.IsSuccess;
import cn.com.qmth.examcloud.support.examing.ExamRecordData;

import java.util.List;

/**
 * @author chenken
 * @date 2018/8/15 11:16
 * @company QMTH
 * @description 考试记录数据服务接口
 */
public interface ExamRecordDataService {

    /**
     * 保存考试记录
     *
     * @param examRecordDataId
     * @param data
     */
    void saveExamRecordDataCache(Long examRecordDataId, ExamRecordData data);

    /**
     * 获取
     *
     * @param examRecordDataId
     * @return
     */
    ExamRecordData getExamRecordDataCache(Long examRecordDataId);

    /**
     * 删除
     *
     * @param examRecordDataId
     */
    void deleteExamRecordDataCache(Long examRecordDataId);

    /**
     * 计算自动审核结果
     *
     * @param isNoPhotoAndIllegality
     * @param faceVerifyResult
     * @param isIllegality
     * @return
     */
    Boolean calcAutoAuditResult(Boolean isNoPhotoAndIllegality, IsSuccess faceVerifyResult, Boolean isIllegality);

    /**
     * 交卷后续处理
     */
    ExamRecordData processAfterHandInExam(Long examRecordDataId);

    ExamRecordData processAfterHandInExam(ExamRecordData examRecordData);

    /**
     * Description 是否开启虚拟摄像头进入待审核
     *
     * @param examId 考试id
     * @return boolean
     */
    boolean isVirtualToWaiting(Long examId);

    /**
     * 按ID分片获取未同步的考试记录列表
     */
    List<ExamRecordDataEntity> getExamRecordDataUnSyncList(int shardTotal, int shardIndex, int batchSize, long startId, ExamRecordStatus... status);

}
