package cn.com.qmth.examcloud.core.oe.task.service.worker;

import cn.com.qmth.examcloud.commons.exception.StatusException;
import cn.com.qmth.examcloud.commons.helpers.concurrency.simple.Worker;
import cn.com.qmth.examcloud.commons.helpers.concurrency.simple.WorkerController;
import cn.com.qmth.examcloud.commons.util.Util;
import cn.com.qmth.examcloud.core.oe.student.dao.enums.ExamCaptureQueueStatus;
import cn.com.qmth.examcloud.core.oe.task.service.ExamCaptureQueueService;
import cn.com.qmth.examcloud.core.oe.task.service.FaceVerifyService;
import cn.com.qmth.examcloud.core.oe.task.service.bean.ExamCaptureQueueInfo;
import cn.com.qmth.examcloud.support.Constants;
import cn.com.qmth.examcloud.web.support.SpringContextHolder;
import org.apache.logging.log4j.ThreadContext;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.concurrent.TimeUnit;

/**
 * 百度活体检测工作线程
 *
 * @author lideyin 20190620
 */
@Deprecated
public class BaiduFaceLivenessWorker implements Worker<ExamCaptureQueueInfo> {

    private static final Logger log = LoggerFactory.getLogger(BaiduFaceLivenessWorker.class);

    @Override
    public void process(WorkerController controller, ExamCaptureQueueInfo element) {
        ThreadContext.put("TRACE_ID", "Q_" + element.getId());
        ThreadContext.put("CALLER", "BAIDU_WORKER");
        FaceVerifyCounter.increaseFaceLivenessDetectCount();
        if (log.isDebugEnabled()) {
            log.debug("[BAIDU_FACELIVENESS_WORKER.] 图片处理数量+1，count= "
                    + FaceVerifyCounter.getFaceLivenessDetectCount());
        }

        FaceVerifyService examCaptureService = SpringContextHolder.getBean(FaceVerifyService.class);
        ExamCaptureQueueService examCaptureQueueService = SpringContextHolder
                .getBean(ExamCaptureQueueService.class);
        try {
            examCaptureService.disposeBaiDuFaceLiveness(element);
        } catch (StatusException e) {
            while (true) {
                // 异常处理
                if (examCaptureQueueService.saveExamCaptureQueueEntityByFailed(element.getId(), e.getDesc(),
                        ExamCaptureQueueStatus.PROCESS_FACELIVENESS_FAILED)) {
                    break;
                }
                ;
                Util.sleep(TimeUnit.MILLISECONDS, 500);
            }
            if ((e.getCode().equals(Constants.BAIDU_FACELIVENESS_QPS_LIMIT_EXCEEDED_CODE))) {
                // 如果超过并发次数，则添加异常次数
                controller.addConcurrencyWarn();
                log.debug("[BAIDU_FACELIVENESS_WORKER.] 超过并发次数 ");
            } else {
                FaceVerifyCounter.increaseFaceLivenessDetectCount();
                log.error("[BAIDU_FACELIVENESS_WORKER.] 自定义异常 " + e.getDesc(), e);
            }
            Util.sleep(TimeUnit.MICROSECONDS, 50);
        } catch (Exception e) {
            FaceVerifyCounter.increaseFaceLivenessDetectCount();
            while (true) {
                // 异常处理
                if (examCaptureQueueService.saveExamCaptureQueueEntityByFailed(element.getId(), "系统异常",
                        ExamCaptureQueueStatus.PROCESS_FACELIVENESS_FAILED)) {
                    break;
                }
                ;
                Util.sleep(TimeUnit.MILLISECONDS, 500);
            }
            log.error("[BAIDU_FACELIVENESS_WORKER.] 系统异常 " + e.getMessage(), e);
            Util.sleep(TimeUnit.MICROSECONDS, 50);
        } finally {
            ThreadContext.clearAll();
        }
    }

}
