package cn.com.qmth.examcloud.core.oe.task.service.worker;

import java.util.concurrent.atomic.AtomicInteger;

/**
 * @Description 考试照片统计控制器
 * @Author lideyin
 * @Date 2019/9/9 17:05
 * @Version 1.0
 */
@Deprecated
public class FaceVerifyCounter {

    //人脸比对处理数量
    private static AtomicInteger faceCompareCount = new AtomicInteger(0);

    //人脸比对处理失败数量
    private static AtomicInteger faceCompareFailedCount = new AtomicInteger(0);

    private static Object facePPLock = new Object();

    private static Object faceLivenessLock = new Object();

    /**
     * 人脸比对总数量自增
     */
    public static void increaseFaceCompareCount() {
        synchronized (facePPLock) {
            faceCompareCount.incrementAndGet();
        }
    }

    /**
     * 人脸比对错误数量自增
     */
    public static void increaseFaceCompareFailedCount() {
        synchronized (facePPLock) {
            faceCompareFailedCount.incrementAndGet();
        }
    }

    /**
     * 同步重置人脸比对所有数量
     */
    public static void resetAllFaceCompareCount() {
        synchronized (facePPLock) {
            faceCompareCount.set(0);
            faceCompareFailedCount.set(0);
        }
    }

    /**
     * 人脸比对总数量
     *
     * @return int
     */
    public static int getFaceCompareCount() {
        synchronized (facePPLock) {
            return faceCompareCount.get();
        }
    }

    /**
     * 人脸比对失败数量
     *
     * @return int
     */
    public static int getFaceCompareFailedCount() {
        synchronized (facePPLock) {
            return faceCompareFailedCount.get();
        }
    }

    /**
     * 人脸比对失败率
     *
     * @return int
     */
    public static int getFaceCompareFailurePercent() {
        synchronized (facePPLock) {
            if (faceCompareCount.get() == 0) {
                return 0;
            }
            return faceCompareFailedCount.get() * 100 / faceCompareCount.get();
        }
    }

    //活体检测处理数量
    private static AtomicInteger faceLivenessDetectCount = new AtomicInteger(0);

    //活体检测处理失败数量
    private static AtomicInteger faceLivenessDetectFailedCount = new AtomicInteger(0);

    /**
     * 活体检测总数量自增
     */
    public static void increaseFaceLivenessDetectCount() {
        synchronized (faceLivenessLock) {
            faceLivenessDetectCount.incrementAndGet();
        }
    }

    /**
     * 活体检测错误数量自增
     */
    public static void increaseFaceLivenessDetectFailedCount() {
        synchronized (faceLivenessLock) {
            faceLivenessDetectFailedCount.incrementAndGet();
        }
    }

    /**
     * 重置活体检测所有数量
     */
    public static void resetAllFaceLivenessDetectCount() {
        synchronized (faceLivenessLock) {
            faceLivenessDetectCount.set(0);
            faceLivenessDetectFailedCount.set(0);
        }
    }

    /**
     * 活体检测总数量
     *
     * @return
     */
    public static int getFaceLivenessDetectCount() {
        synchronized (faceLivenessLock) {
            return faceLivenessDetectCount.get();
        }
    }

    /**
     * 活体检测失败数量
     *
     * @return
     */
    public static int getFaceLivenessDetectFailedCount() {
        synchronized (faceLivenessLock) {
            return faceLivenessDetectFailedCount.get();
        }
    }

    /**
     * 活体检测失败率
     *
     * @return int
     */
    public static int getFaceLivenessDetectFailurePercent() {
        synchronized (faceLivenessLock) {
            if (faceLivenessDetectCount.get() == 0) {
                return 0;
            }
            return faceLivenessDetectFailedCount.get() * 100 / faceLivenessDetectCount.get();
        }
    }

}
