package cn.com.qmth.examcloud.core.oe.task.starter.config;

import cn.com.qmth.examcloud.commons.helpers.pipeline.Node;
import cn.com.qmth.examcloud.commons.helpers.pipeline.SimpleNode;
import cn.com.qmth.examcloud.commons.helpers.pipeline.TaskContext;
import cn.com.qmth.examcloud.core.oe.task.service.pipeline.*;
import cn.com.qmth.examcloud.support.examing.ExamRecordData;
import cn.com.qmth.examcloud.web.bootstrap.PropertyHolder;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.ApplicationArguments;
import org.springframework.boot.ApplicationRunner;
import org.springframework.core.annotation.Order;
import org.springframework.stereotype.Component;

/**
 * @Description 流式任务执行器
 * @Author lideyin
 * @Date 2019/12/24 15:52
 * @Version 1.0
 */
@Deprecated
@Component
@Order(300)
public class StreamTaskExecutor implements ApplicationRunner {

    private static final Logger LOG = LoggerFactory.getLogger(StreamTaskExecutor.class);

    @Autowired
    private DataGainExamExecutor dataGainExamExecutor;

    @Autowired
    private HandInExamExecutor handInExamExecutor;

    @Autowired
    private AfterHandInExamExecutor afterHandInExamExecutor;

    @Autowired
    private SyncExamDataExecutor syncExamDataExecutor;

    @Autowired
    private ClearExamDataCacheExecutor clearExamDataCacheExecutor;

    @Value("${examcloud.record.data.sync.enable}")
    private Boolean recordDataSyncEnable;

    private static Integer DEFAULT_GAIN_EXAM_DATA_EXECUTOR_SLEEP_SECONDS = 2;

    private static Integer DEFAULT_HAND_IN_EXAM_EXECUTOR_SLEEP_SECONDS = 2;

    private static Integer DEFAULT_AFTER_HAND_IN_EXAM_EXECUTOR_SLEEP_SECONDS = 1;

    private static Integer DEFAULT_SYNC_EXAM_DATA_EXECUTOR_SLEEP_SECONDS = 1;

    private static Integer DEFAULT_CLEAR_EXAM_DATA_CACHE_EXECUTOR_SLEEP_SECONDS = 1;

    @Override
    public void run(ApplicationArguments args) throws Exception {
        // boolean recordDataSyncEnable = PropertyHolder.getBoolean("examcloud.record.data.sync.enable", false);
        LOG.warn("examcloud.record.data.sync.enable = " + recordDataSyncEnable);
        if (recordDataSyncEnable) {
            // initExecutor();
        }
    }

    private void initExecutor() {
        TaskContext context = new TaskContext();

        Node<Long, ExamRecordData, Long, ExamRecordData> node1 = new SimpleNode<>(
                "gainExamData", dataGainExamExecutor, context);

        Node<Long, ExamRecordData, Long, ExamRecordData> node2 = new SimpleNode<>(
                "handInExam", handInExamExecutor, context);

        Node<Long, ExamRecordData, Long, ExamRecordData> node3 = new SimpleNode<>(
                "afterHandInExam", afterHandInExamExecutor, context);

        Node<Long, ExamRecordData, Long, ExamRecordData> node4 = new SimpleNode<>(
                "syncExamData", syncExamDataExecutor, context);

        Node<Long, ExamRecordData, Long, ExamRecordData> node5 = new SimpleNode<>(
                "clearExamDataCache", clearExamDataCacheExecutor, context);

        node1.setFirst(true);
        node1.setLowerNode(node2);
        node1.setSleep(PropertyHolder.getInt("oeTask.executor.gainExamData.sleep",
                DEFAULT_GAIN_EXAM_DATA_EXECUTOR_SLEEP_SECONDS));//单位秒

        node2.setLowerNode(node3);
        node2.setSleep(PropertyHolder.getInt("oeTask.executor.handInExam.sleep",
                DEFAULT_HAND_IN_EXAM_EXECUTOR_SLEEP_SECONDS));//单位秒

        node3.setLowerNode(node4);
        node3.setSleep(PropertyHolder.getInt("oeTask.executor.afterHandInExam.sleep",
                DEFAULT_AFTER_HAND_IN_EXAM_EXECUTOR_SLEEP_SECONDS));//单位秒

        node4.setLowerNode(node5);
        node4.setSleep(PropertyHolder.getInt("oeTask.executor.syncExamData.sleep",
                DEFAULT_SYNC_EXAM_DATA_EXECUTOR_SLEEP_SECONDS));//单位秒

        node5.setSleep(PropertyHolder.getInt("oeTask.executor.clearExamDataCache.sleep",
                DEFAULT_CLEAR_EXAM_DATA_CACHE_EXECUTOR_SLEEP_SECONDS));//单位秒

        node1.start();
        node2.start();
        node3.start();
        node4.start();
        node5.start();
    }

}
